"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.triggerStaticRegeneration = void 0;
const s3BucketNameFromEventRequest_1 = require("../s3/s3BucketNameFromEventRequest");
const crypto = __importStar(require("crypto"));
const triggerStaticRegeneration = async (options) => {
    var _a, _b, _c;
    const { region } = ((_a = options.request.origin) === null || _a === void 0 ? void 0 : _a.s3) || {};
    const bucketName = (0, s3BucketNameFromEventRequest_1.s3BucketNameFromEventRequest)(options.request);
    const queueName = options.queueName;
    if (!bucketName) {
        throw new Error("Expected bucket name to be defined");
    }
    if (!region) {
        throw new Error("Expected region to be defined");
    }
    const { SQSClient, SendMessageCommand } = await Promise.resolve().then(() => __importStar(require("@aws-sdk/client-sqs")));
    const sqs = new SQSClient({
        region,
        maxAttempts: 1
    });
    const regenerationEvent = {
        region,
        bucketName,
        cloudFrontEventRequest: options.request,
        basePath: options.basePath,
        pagePath: options.pagePath
    };
    try {
        const hashedUri = crypto
            .createHash("md5")
            .update(options.request.uri)
            .digest("hex");
        await sqs.send(new SendMessageCommand({
            QueueUrl: `https://sqs.${region}.amazonaws.com/${queueName}`,
            MessageBody: JSON.stringify(regenerationEvent),
            MessageDeduplicationId: ((_b = options.response.headers["etag"]) === null || _b === void 0 ? void 0 : _b[0].value) ||
                new Date((_c = options.response.headers["last-modified"]) === null || _c === void 0 ? void 0 : _c[0].value)
                    .getTime()
                    .toString(),
            MessageGroupId: hashedUri
        }));
        return { throttle: false };
    }
    catch (error) {
        if (error.code === "RequestThrottled") {
            return { throttle: true };
        }
        else {
            throw error;
        }
    }
};
exports.triggerStaticRegeneration = triggerStaticRegeneration;
